"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var LimberLinkEditorComponent = (function () {
    function LimberLinkEditorComponent() {
        var _this = this;
        // @ViewChild('fontAwesomeModal')
        // fontAwesomeModal: ModalDirective;
        this.iconFilter = '';
        this.selectionChanged = new core_1.EventEmitter();
        this.save = new core_1.EventEmitter();
        this.reset = new core_1.EventEmitter();
        this.cancel = new core_1.EventEmitter();
        this.showIconPicker = function () {
            console.log('show icon picker!');
            // this.fontAwesomeModal.show();
        };
        this.hideIconPicker = function () {
            console.log('hide icon picker!');
            // this.fontAwesomeModal.hide();
        };
        this.setIcon = function (icon) {
            _this.link.faIcon = '';
            if (!!icon) {
                _this.link.faIcon = icon;
            }
            _this.hideIconPicker();
        };
        this.setFaIcon = function (icon) {
            _this.link.faIcon = icon;
            _this.hideIconPicker();
        };
        this.resetProp = function (obj, prop, value) {
            obj[prop] = value;
        };
        // callback stuff
        this.emitSave = function () { _this.save.emit(null); };
        this.emitReset = function () { _this.reset.emit(null); };
        this.emitCancel = function () {
            _this.link = null;
            _this.cancel.emit(null);
        };
        this.emitSelected = function () { _this.selectionChanged.emit(_this.link); };
        this.edit = function (l) {
            if (l) {
                // clone the link
                _this.link = l;
                _this.workingLink = JSON.parse(JSON.stringify(l));
                _this.emitSelected();
            }
        };
        this.insertAt = function (index) {
            var newLink = { text: 'new link' };
            // insert at 0
            if (index === null) {
                _this.links.unshift(newLink);
            }
            else if (index + 1 === _this.links.length) {
                _this.links.push(newLink);
            }
            else {
                _this.links.splice(index + 1, 0, newLink);
            }
        };
        this.removeAt = function (index) {
            if (index !== null) {
                if (index > -1 || index < _this.links.length) {
                    var link = _this.links[index];
                    if (link) {
                        if (confirm("Are you sure you want to remove " + link.text) === true) {
                            if (link.id === _this.link.id) {
                                _this.link = null;
                            }
                            _this.links.splice(index, 1);
                        }
                    }
                }
            }
        };
    }
    Object.defineProperty(LimberLinkEditorComponent.prototype, "link", {
        get: function () { return this._link; },
        set: function (l) {
            this._link = l;
            // make a sloppy-copy of the link selected
            this._workingCopy = JSON.parse(JSON.stringify(l));
        },
        enumerable: true,
        configurable: true
    });
    LimberLinkEditorComponent.prototype.ngOnInit = function () { };
    LimberLinkEditorComponent.prototype.ngAfterViewInit = function () {
        // this.fontAwesomeModal.config.backdrop = false;
    };
    return LimberLinkEditorComponent;
}());
LimberLinkEditorComponent.decorators = [
    { type: core_1.Component, args: [{
                // moduleId: module.id,
                selector: "limber-link-editor",
                template: "\n    <div class=\"fields select-nav\">\n        <div class=\"insert\" (click)=\"insertAt(null)\"> <font-awesome class=\"buttons add\" faIcon=\"plus\"></font-awesome> </div>\n        <span *ngFor=\"let link of links; let i = index;\">\n          <div class=\"link\" (click)=\"edit(link)\">\n            <font-awesome class=\"buttons remove\" (click)=\"removeAt(i)\" faIcon=\"remove\"></font-awesome>\n            <limber-button [isButton]=\"true\" [text]=\"link.text\" [icon]=\"link.faIcon\" [image]=\"link.img\" href=\"#\" [route]=\"null\" [href]=\"null\" [id]=\"link.id\"></limber-button>\n          </div>\n          <div class=\"insert\" (click)=\"insertAt(i)\"> <span class=\"buttons add\"><font-awesome  faIcon=\"plus\"></font-awesome></span> </div>\n        </span>\n      <!--<ul>\n        <li class=\"insert\"></li>\n        <li class=\"link\" *ngFor=\"let link of links\" (click)=\"edit(link)\">\n        {{link.text}}\n        <li class=\"sub insert\"></li>\n        <li *ngFor=\"let n of link.links\" class=\"dropdown-item\" (click)=\"edit(n)\">\n          {{n.text}}\n        </li>\n        <li class=\"insert\"></li>\n      </ul>-->\n    </div>\n    <div class=\"fields edit-nav\">\n      <form *ngIf=\"link\" #limberLinkForm>\n        <div>\n          <div>\n            <label class=\"field\"><span class=\"field_header\">text</span>\n              <clear-button [clearValue]=\"''\" (clear)=\"resetProp(link, 'text', $event)\"></clear-button>\n              <input name=\"text\" [(ngModel)]=\"link.text\">\n              <clipboard-component [faIcon]=\"true\" [altText]=\"'copy text'\" [content]=\"link.text\"></clipboard-component>\n            </label>\n            <label class=\"field\"><span class=\"field_header\">route</span>\n              <clear-button [clearValue]=\"''\" (clear)=\"resetProp(link, 'route', $event)\"></clear-button>\n              <input name=\"route\" [(ngModel)]=\"link.route\">\n              <clipboard-component [faIcon]=\"true\" [altText]=\"'copy route'\" [content]=\"link.route\"></clipboard-component>\n            </label>\n            <label class=\"field\"><span class=\"field_header\">href</span>\n              <clear-button [clearValue]=\"''\" (clear)=\"resetProp(link, 'href', $event)\"></clear-button>\n              <input name=\"href\" [(ngModel)]=\"link.href\">\n              <clipboard-component [faIcon]=\"true\" [altText]=\"'copy href'\" [content]=\"link.href\"></clipboard-component>\n            </label>\n            <label class=\"field\" style=\"display: inline-block\"><span class=\"field_header\" (click)=\"showIconPicker()\">icon</span></label>\n              <clear-button [clearValue]=\"''\" (clear)=\"resetProp(link, 'faIcon', $event)\"></clear-button>        \n              <button type=\"button\" (click)=\"showIconPicker()\">\n                <font-awesome *ngIf=\"link.faIcon\" [faIcon]=\"link.faIcon\"></font-awesome>\n                {{link.faIcon}}\n                <span *ngIf=\"!link.faIcon\">Pick an icon</span>\n              </button>\n            <label class=\"field\"><span class=\"field_header\">img</span>\n              <clear-button [clearValue]=\"''\" (clear)=\"resetProp(link, 'img', $event)\"></clear-button>\n              <input name=\"img\" [(ngModel)]=\"link.img\">\n              <clipboard-component [faIcon]=\"true\" [altText]=\"'copy image url'\" [content]=\"link.img\"></clipboard-component>\n            </label>\n            <!--<label class=\"field\"><span class=\"field_header\">id</span><input name=\"id\" [(ngModel)]=\"link.id\" disabled></label>-->\n          </div>\n        </div>\n        <div class=\"buttons\">\n          <button type=\"button\" (click)=\"emitSave()\">Save</button>\n          <button type=\"button\" (click)=\"emitReset()\">Reset</button>\n          <button type=\"button\" (click)=\"emitCancel()\">Cancel</button>\n        </div>\n      </form>\n    </div>\n    <!--fixme: bring font-awesome picker over to this limber-link-group and wire it up via event emitters-->\n    <!--todo: add / remove / re-order functionality -->\n    <!--<div bsModal #fontAwesomeModal=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\" [config]=\"{backdrop: 'static'}\">\n      <div class=\"modal-dialog modal-lg\">\n        <div class=\"modal-content\">\n          <div class=\"modal-header\">\n            <h4 class=\"modal-title\" style=\"display: inline-block\">Icon Selection <span style=\"float: right;\"><button type=\"button\" (click)=\"setIcon($event)\">No Icon</button><label>filter<input type=\"text\" [(ngModel)]=\"iconFilter\"></label></span></h4>\n          </div>\n          <div class=\"modal-body\">\n            <font-awesome-grid (pick)=\"setIcon($event)\" [filter]=\"iconFilter\"></font-awesome-grid>\n        \n          </div>\n        </div>\n      </div>\n    </div>-->\n  ",
                styles: ["\n    :host { color: black; }\n\n    :host .fields { display: inline-block; max-width: 570px; background-color: skyblue; border: 1px solid #1f8dba; overflow-y: auto; }\n\n    :host .fields.select-nav, :host .fields.edit-nav { padding-top: 5px; padding-bottom: 5px; padding-right: 5px; height: 290px; width: 350px; }\n\n    :host .fields.select-nav { border: 1px solid #1f8dba; }\n\n    :host .fields.select-nav div { padding-left: 5px; cursor: pointer; border-radius: 3px; /* \"buttons\" */ }\n\n    :host .fields.select-nav div .buttons { visibility: hidden; cursor: pointer; margin-right: 5px; padding: 0px 3px 0px 3px; border: 1px solid black; border-radius: 3px; box-shadow: 1px 1px 3px rgba(0, 0, 0, 0.5); }\n\n    :host .fields.select-nav div .buttons.add, :host .fields.select-nav div .buttons.remove { color: white; }\n\n    :host .fields.select-nav div .buttons.add { background-color: limegreen; }\n\n    :host .fields.select-nav div .buttons.remove { background-color: darkred; }\n\n    :host .fields.select-nav div:hover .buttons { visibility: visible; }\n\n    :host .fields.select-nav div.link, :host .fields.select-nav div.insert { margin-top: 3px; margin-bottom: 3px; padding-top: 5px; padding-bottom: 7px; }\n\n    :host .fields.select-nav div.link { box-shadow: 1px 1px 3px rgba(0, 0, 0, 0.5); background-color: #c9e9f6; border-bottom: 1px solid gray; border-top: 1px solid #b3b3b3; border-right: 1px solid #b3b3b3; }\n\n    :host .fields.select-nav div.link:hover { background-color: white; }\n\n    :host .fields.select-nav div.insert { height: 28px; margin-top: 8px; margin-bottom: 8px; }\n\n    :host .fields.select-nav div.insert:hover { background-color: #5bbce4; box-shadow: 1px 1px 3px rgba(0, 0, 0, 0.5); }\n\n    :host .fields.icons { padding: 3px; border-top-left-radius: 5px; border-bottom-left-radius: 5px; max-height: 290px; position: absolute; bottom: 3px; }\n\n    :host span.icon { background-color: #fff; border: 1px solid black; width: 24px; display: block; }\n\n    :host .icon_picker_column span { display: inline-block; }\n\n    :host .icon { background-color: #c9e9f6; border: 2px solid black; border-radius: 5px; padding: 3px; display: inline-block; }\n\n    :host .icon:hover { background-color: #f4fbfd; cursor: pointer; }\n\n    :host .icon { width: 100px; max-height: 100px; overflow-y: hidden; overflow-x: hidden; }\n\n    :host .icon span.description { max-height: 58px; overflow: hidden; }\n\n    :host label.field { display: block; }\n\n    :host label.field .field_header { cursor: pointer; text-transform: capitalize; display: inline-block; padding-left: 5px; width: 70px; }\n\n    :host label clipboard-component { visibility: hidden; }\n\n    :host label:hover clipboard-component { visibility: visible; }\n\n    :host .close_button { box-shadow: 1px 1px 5px black; border-radius: 5px; float: right; cursor: pointer; }\n\n    :host input { border: 1px solid black; border-radius: 3px; box-shadow: 1px 1px 3px rgba(0, 0, 0, 0.5); }\n  "]
            },] },
];
/** @nocollapse */
LimberLinkEditorComponent.ctorParameters = function () { return []; };
LimberLinkEditorComponent.propDecorators = {
    'link': [{ type: core_1.Input },],
    'links': [{ type: core_1.Input },],
    'selectionChanged': [{ type: core_1.Output },],
    'save': [{ type: core_1.Output },],
    'reset': [{ type: core_1.Output },],
    'cancel': [{ type: core_1.Output },],
};
exports.LimberLinkEditorComponent = LimberLinkEditorComponent;
//# sourceMappingURL=limber-link-editor.component.js.map
//# sourceMappingURL=limber-link-editor.component.js.map
