"use strict";
// greg hedin
// a component for populating and editing navigation links programmatically
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
// import { LimberLinkEditorComponent } from '../limber-editors/limber-link-editor/limber-link-editor.component';
var LimberLinkGroupComponent = (function () {
    // constructor(private http: Http, private dragulaService: DragulaService) {
    //   dragulaService.setOptions('nav-bag', {revertOnSpill: true});
    function LimberLinkGroupComponent(http) {
        var _this = this;
        this.http = http;
        this.allowEdit = false;
        this.editMode = false;
        this.httpGet = function () {
            return _this.http.get(_this.endPoint).map(function (response) { return response.json(); });
        };
        // httpSave = (): Observable<ILimberLink[]> => {
        //   return this.http.post(this.endPoint, JSON.stringify(this.links)).map(response => response.json());
        // };
        this.toggleEditMode = function (on) { _this.editMode = on; };
        this.linksToJson = function () { return JSON.stringify(_this.links, null, 2); };
        this.getLinks = function () {
            if (_this.endPoint) {
                // todo: consider generating UUIDs or require the 'id' property in the ILimberLink interface.
                _this.httpGet().subscribe(function (result) {
                    _this.links = result;
                    _this.initLinks();
                });
            }
        };
        this.editLink = function (link) {
            _this.selectedLink = JSON.parse(JSON.stringify(link));
            _this.showEditor();
        };
        this.resetSelected = function (e) {
            _this.links.forEach(function (link) {
                if (link.id === _this.selectedLink.id) {
                    _this.editLink(link);
                    return;
                }
            });
            // delete this.selectedLink;
        };
        this.saveSelected = function (e) {
            _this.hideEditor();
            // this.links = this.links.concat();
            // let i = -1;
            // this.links.forEach((link, index) => {
            //   if (link.id === this.selectedLink.id) {
            //     i = index;
            //     this.hideEditor();
            //     return;
            //     // this.links.splice(this.links.indexOf(link), 1, this.selectedLink);
            //     // this.links = this.links.concat([]);
            //   } else {
            //     link.links.forEach((l, ind) => {
            //     if (l.id === this.selectedLink.id) {
            //       i = index;
            //       this.hideEditor();
            //       return;
            //     }
            //   });
            // }
            // });
            // if (i !== -1) {
            //   this.links.splice(i, 1, JSON.parse(JSON.stringify(this.selectedLink)));
            //   this.links = this.links.concat([]);
            // } else {
            //   console.log('failed to save link: %s', JSON.stringify(this.selectedLink));
            // }
            if (_this.endPoint) {
                // todo: save via web API
                // try-http-post
                // this.httpSave().subscribe(result => this.links = result);
            }
            // this.selectedLink = null;
        };
        this.cancelEdit = function (e) {
            _this.hideEditor();
            _this.selectedLink = null;
        };
        this.updateSelected = function (l) {
            _this.selectedLink = l;
        };
        this.addNewLink = function () {
            var newLink = { text: 'new link', id: LimberLinkGroupComponent.nextId++ };
            _this.links = _this.links.concat([newLink]);
        };
        this.launchEditor = function () {
            _this.showEditor();
        };
    }
    // modal stuff
    // @ViewChild('editorModal')
    // editorModal: ModalDirective;
    LimberLinkGroupComponent.prototype.showEditor = function () {
        console.log('show editor');
        // this.editorModal.show();
    };
    LimberLinkGroupComponent.prototype.hideEditor = function () {
        console.log('hide editor');
        // this.editorModal.hide();
    };
    // load the list of navs
    // if there are no css classes to passthru, default to 'navbar' 
    LimberLinkGroupComponent.prototype.ngOnInit = function () {
        this.initLinks();
        if (!this.navClass) {
            this.navClass = 'nav navbar';
        }
    };
    /*  ngOnDestroy() {
        // this.dragulaService.destroy('nav-bag');
      }*/
    // ngAfterViewInit() {
    //   this.editorModal.config.backdrop = false;
    // }
    LimberLinkGroupComponent.prototype.initLinks = function () {
        var _this = this;
        if (!this.links) {
            this.getLinks();
        }
        else {
            this.links.forEach(function (link) {
                link.id = LimberLinkGroupComponent.nextId++;
                if (_this.customize) {
                    link = _this.customize(link);
                }
                // continue recursively down the dropdown components
                if (link.links) {
                    link.links.forEach(function (n) {
                        n.id = LimberLinkGroupComponent.nextId++;
                        if (_this.customize) {
                            n = _this.customize(n);
                        }
                    });
                }
            });
        }
    };
    return LimberLinkGroupComponent;
}());
// fixme: this is a crutch for generating IDs.
LimberLinkGroupComponent.nextId = 0;
LimberLinkGroupComponent.decorators = [
    { type: core_1.Component, args: [{
                // moduleId: module.id,
                selector: 'limber-link-group',
                template: "\n    <div>\n      <span>\n        <div *ngIf=\"allowEdit\">\n          <limber-toggler [ngClass]=\"{'on': editMode, 'off': !editMode}\" [onToggle]=\"toggleEditMode\"></limber-toggler>  \n          <span class=\"toolbar\" *ngIf=\"editMode\">\n            <!--<span class=\"toolbarButton add\"><font-awesome [faIcon]=\"'plus-square'\" (click)=\"addNewLink()\"></font-awesome></span>\n            <span class=\"toolbarButton remove\"><font-awesome [faIcon]=\"'minus-square'\"></font-awesome></span>-->\n            <span class=\"toolbarButton edit\"><font-awesome [faIcon]=\"'wrench'\" (click)=\"launchEditor()\"></font-awesome></span>\n            <span class=\"toolbarButton copyJson\"><clipboard-component *ngIf=\"editMode\" [noClass]=\"true\" [faIcon]=\"true\" [altText]=\"'copy JSON'\" [content]=\"linksToJson()\"></clipboard-component></span>\n          </span>\n          <!--<limber-link-editor *ngIf=\"editMode && selectedLink\" [link]=\"selectedLink\" id=\"limber-link-editor\"-->\n        </div>\n      <ul [class]=\"navClass\">\n        <!-- todo: add dragula (dragula currently breaks AOT) -->\n        <!--<li class=\"nav-item\" [dragula]=\"nav-bag\" [dragulaModel]=\"links\" *ngFor=\"let link of links\">-->\n          <li class=\"nav-item\" *ngFor=\"let link of links\">\n          <!--<limber-link [link]=\"link\" [editMode]=\"editMode\" [edit]=\"editLink\"></limber-link>-->\n          <limber-link *ngIf=\"link.route || link.href || link.action\" [link]=\"link\" [editMode]=\"editMode\" [edit]=\"editLink\"></limber-link>\n        </li>\n      </ul>\n      </span>\n      <!--fixme: bring font-awesome picker over to this limber-link-group and wire it up via event emitters-->\n      <!--<div bsModal #editorModal=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\" [config]=\"{backdrop: 'static'}\">\n        <div class=\"modal-dialog modal-lg\">\n          <div class=\"modal-content\">\n            <div class=\"modal-header\">\n              <h4 class=\"modal-title\">Link Editor\n                <button type=\"button\" class=\"close\" aria-label=\"Close\" (click)=\"cancelEdit($event)\">\n                  <span aria-hidden=\"true\">&times;</span>\n                </button>\n              </h4>\n            </div>\n            <div class=\"modal-body\">\n              <limber-link-editor #editor [links]=\"this.links\" (selectionChanged)=\"updateSelected($event);\" id=\"limber-link-editor\"\n                (save)=\"saveSelected($event)\"\n                (reset)=\"resetSelected($event)\"\n                (cancel)=\"cancelEdit($event)\">\n              </limber-link-editor>\n            </div>\n          </div>\n        </div>\n      </div>-->\n    </div>\n  ",
                styles: ["\n    :host li.nav-item { display: 'inline-block'; }\n\n    :host.editMode { border: 1px solid red; }\n\n    :host .modal-content { background-color: skyblue; border-radius: 5px; box-shadow: 1px 1px 5px black; }\n\n    :host .modal-header { background-color: #fff; color: black; border-top-left-radius: 5px; border-top-right-radius: 5px; }\n\n    :host .toolbar { padding: 3px; background-color: #fff; }\n\n    :host .toolbar .toolbarButton { cursor: pointer; font-size: 22px; margin: 1px; }\n\n    :host .toolbar .toolbarButton.add { color: green; }\n\n    :host .toolbar .toolbarButton.remove { color: red; }\n\n    :host .toolbar .toolbarButton.edit { color: black; }\n\n    :host .toolbar .toolbarButton.copyJson { color: black; }\n  "]
            },] },
];
/** @nocollapse */
LimberLinkGroupComponent.ctorParameters = function () { return [
    { type: http_1.Http, },
]; };
LimberLinkGroupComponent.propDecorators = {
    'endPoint': [{ type: core_1.Input },],
    'navClass': [{ type: core_1.Input },],
    'allowEdit': [{ type: core_1.Input },],
    'customize': [{ type: core_1.Input },],
    'links': [{ type: core_1.Input },],
};
exports.LimberLinkGroupComponent = LimberLinkGroupComponent;
//# sourceMappingURL=limber-link-group.component.js.map
//# sourceMappingURL=limber-link-group.component.js.map
