"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var LimberLinkComponent = (function () {
    function LimberLinkComponent() {
        var _this = this;
        this.editMode = false;
        this.mouseHover = false;
        this.onClick = function (e) {
            if (_this.editMode) {
                // do stuff
                // console.log('edit');
                // this.edit(this.link);
                e.preventDefault();
            }
        };
        this.isActive = function () {
            var path = window.location.pathname.replace(/^\//, '');
            if (path === _this.link.route) {
                return true;
            }
            return false;
        };
        this.isDropdown = function () {
            return !!_this.link.links;
        };
        this.isDropdownItem = function () {
            return _this.dropdownItem;
        };
        this.resolveClass = function () {
            var cssClass = 'nav-link';
            // if this is a dropdown-item, return immediately.
            if (_this.dropdownItem) {
                return 'dropdown-item';
            }
            // add necessary bootstrap classes.
            // if (this.isActive()) {
            //   cssClass += ' active';
            // }
            // if (this.isDropdown()) {
            //   cssClass += ' dropdown-toggle dropdown';
            //   }
            return cssClass;
        };
    }
    LimberLinkComponent.prototype.ngOnInit = function () {
        // setInterval( () => {
        //   console.log('mouseHover:', this.mouseHover);
        // }, 500);
    };
    return LimberLinkComponent;
}());
LimberLinkComponent.decorators = [
    { type: core_1.Component, args: [{
                // moduleId: module.id,
                selector: 'limber-link',
                template: "\n    <!--\n      create a nav-link.\n      if it is not a dropdown, use the first chunk of markup\n      if it is a drop down use the second chunk\n      --------\n      in either case, if it is active:\n        add the 'active' class\n        inform the screen reader\n      if its favicon is truthy, display it.\n      -->\n      <!-- render a hyperlink or routerlink-->\n      <span *ngIf=\"!isDropdown()\">\n        <limber-button [isButton]=\"false\" [text]=\"link.text\" [buttonClass]=\"resolveClass()\" [icon]=\"link.faIcon\" [image]=\"link.img\" href=\"#\" [route]=\"editMode ? null : link.route\" [href]=\"link.href\" [id]=\"link.id\" [callback]=\"onClick\">\n          <span *ngIf=\"isActive()\" class=\"sr-only\">(current)</span>\n        </limber-button>\n      </span>\n\n      <!-- render a dropdown -->\n      <span *ngIf=\"isDropdown()\" [ngClass]=\"mouseHover ? 'hover' : ''\" (mouseover)=\"mouseHover = true;\" (mouseout)=\"mouseHover = false\" >\n        <limber-button [isButton]=\"false\" [text]=\"link.text\" [buttonClass]=\"resolveClass()\" [icon]=\"link.faIcon\" [image]=\"link.img\" [callback]=\"onClick\">\n          <span *ngIf=\"isActive()\" class=\"sr-only\">(current)</span>\n        </limber-button>\n      <ul class=\"dropdown-menu dropdown-menu-dp\" attr.aria-labelledby=\"{{link.text | hyphenate}}\" >\n        <li *ngFor=\"let l of link.links\"><limber-link [link]=\"l\" [editMode]=\"editMode\" [edit]=\"edit\" [dropdownItem]=\"true\" [id]=\"l.id\"></limber-link></li>\n      </ul>\n    </span>\n  ",
                styles: ["\n    :host .hover .dropdown-menu { display: block; }\n\n    :host a { display: inline-block; }\n\n    :host .dropdown-menu { display: none; position: absolute; }\n  "]
            },] },
];
/** @nocollapse */
LimberLinkComponent.ctorParameters = function () { return []; };
LimberLinkComponent.propDecorators = {
    'link': [{ type: core_1.Input },],
    'dropdownItem': [{ type: core_1.Input },],
    'editMode': [{ type: core_1.Input },],
    'edit': [{ type: core_1.Input },],
};
exports.LimberLinkComponent = LimberLinkComponent;
//# sourceMappingURL=limber-link.component.js.map
//# sourceMappingURL=limber-link.component.js.map
